import h5py as h5
import numpy as np
import matplotlib.pyplot as plt
import numpy.ma as ma
import matplotlib as mpl

import scipy.linalg as linalg
import scipy.sparse as sparse

"""
The functions here plot the figures that appear in ICCS paper.
It's assumed we already have the .h5 files required (generated by the .cpp scripts)
"""

plt.rcParams.update({
    "mathtext.fontset": "cm",
    "font.family": "STIXGeneral",
    "text.usetex": False,
    "axes.formatter.use_mathtext": True,
    "xtick.labelsize": 12,
    "ytick.labelsize": 12,
    "axes.labelsize": 14
})
mpl.rcParams['axes.prop_cycle'] = mpl.cycler(color=["blue", "red", "orange", "green", "purple", "brown"]) 

def getContent(filename):
    """Helper function to transform .h5 file into a dict"""
    
    f = h5.File(filename)
    res = {}
    for key in f.keys():
        res[key] = f[key][:]
    f.close()
    return res

def f(x,y,lap=False):
    """Return test function (sinx siny) value and derivative"""
    
    if (lap):
        return -2*np.pi*np.pi*f(x,y)
    else:
        return np.sin(np.pi*x)*np.sin(np.pi*y)

def bndBall(xx,yy):
    """Returns true if x,y are boundary points of the domain"""
    x = xx-0.5
    y = yy-0.5
    if abs(x*x+y*y-0.5*0.5)<1e-8:
        return True
    return False

bndBallVec = np.vectorize(bndBall)


def addArrow(fig, ax1, ax2, xyA, xyB):
    """Helper function to draw an arrow between subplots"""
    
    transFigure = fig.transFigure.inverted()
    line = mpl.patches.ConnectionPatch(
        xyA,  # xdata
        xyB,  # ydata
        coordsA=ax1.transData,
        coordsB=ax2.transData,
        color="black",
        arrowstyle = "-|>",
        mutation_scale=20,
        linewidth=1,
    )
    fig.patches.append(line)

def adjustTickFont(*axes, labelsize=20):
    """Helper function to adjust tick font size easily"""
    
    for ax in axes:
        ax.tick_params(axis='both', which='major', labelsize=labelsize)
        ax.tick_params(axis='both', which='minor', labelsize=labelsize)

def obtainErrorBounds(fname,n,funk=f): #TODO bndball
    """Obtain min and max error for a given approximation"""
    
    d = getContent(fname)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy, in zip(x,y)]
    u = d[f'SolutionN{n}']
    u = u-real
    return [np.amin(u),np.amax(u)]

def checkLaplaceErrors(fname, ax, aggFunk = np.amax, funk=None, numberMetric = False):
    """Produce an Error(support size) plot.
    fname - filename with results
    ax - to plot it on
    aggFunk - l_inf or l_2 error
    funk - real solution
    numberMetric - whether to plot error or our introduced metric
    """
    
    if funk is None:
        funk = lambda x,y : f(x,y,True)
    d = getContent(fname)
    x,y = d['positions']
    realVals = []
    toDelete = []
    for i in range(len(x)):
        realVals.append(funk(x[i],y[i]))
        if bndBall(x[i],y[i]):
            toDelete.append(i) #boundary node not included in averaging
    errors = []
    for n in d['support']:
        if numberMetric:
            error = d[f'derXSize{n}']-np.array(realVals)
            numPlus = len(error[error > 0])
            numMinus = len(error[error < 0])
            errors.append((numPlus-numMinus)/(numPlus+numMinus))
        else:
            error = np.abs(np.array(realVals)-d[f'derXSize{n}'])
            errors.append(aggFunk(np.delete(error,toDelete)))
    #errors = np.array(errors)
    #absmax = np.amax(np.abs(errors))
    #errors = errors/absmax
    ax.plot(d['support'],errors, ls="-", marker=".")
    if not numberMetric:
        ax.set_yscale("log")
    
    
def checkPoisson(filename, support, ax, funk=f, aggFunk = np.amax, numberMetric = False):
    """Produce an Error(support size) plot.
    
    fname - filename with results
    support - array of support sizes
    ax - the ax to plot on
    funk - real solution
    aggFunk - function to aggregate point  value errors in a single one
    numberMetric - whether to plot actual errors or just the inroduced metric
    """
    
    d = getContent(filename)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy in zip(x,y)]
    absErrors = []
    for n in support:
        u = d[f'SolutionN{n}']
        if numberMetric:
            numPlus = len((u-real)[u-real > 0])
            numMinus = len((u-real)[u-real < 0])
            absErrors.append((numPlus-numMinus)/(numPlus+numMinus))
        else:
            absErrors.append(aggFunk(np.abs(real-u)))
    ax.plot(support,absErrors,ls="-", marker=".")
    if not numberMetric:
        ax.set_yscale("log")



poissonErrors = [np.inf, -np.inf]
lapErrors = [np.inf, -np.inf]
 
    
def plotPoissonErrorContour(filename, n, ax, funk=f, vmin=-100,vmax=100, normalise=False, color="viridis"):
    """Plot the spatial dependence of Poisson Eq sol. error
    
    filename - filename with our approximations
    n - stencil size
    ax - to plot it on
    funk - real solution
    vmin - vmin to use in colorscale
    vmax - vmax to use in colorscale
    normalise - whether to normalise the errors to +-1
    color - cmap used (string)
    """
    
    d = getContent(filename)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy in zip(x,y)]
    absErrors = []
    u =  d[f'SolutionN{n}'] - real
    if normalise:
        u = np.array([1 if i>=0 else -1 for i in u])
    maska = bndBallVec(x,y)
    x = ma.array(x, mask=maska)
    y = ma.array(y, mask=maska)
    u = ma.array(u, mask=maska)
    poissonErrors[0] = min(np.amin(u),poissonErrors[0]) 
    poissonErrors[1] = max(np.amax(u),poissonErrors[1])
    cmap=plt.get_cmap(color)
    norm = mpl.colors.SymLogNorm(1e-7, vmin=vmin, vmax=vmax) 
    #ax.scatter(x,y,c=u,s=0.1)
    ax.scatter(x,y,c=u,norm=norm,s=0.1, cmap=cmap)
    #ax.set_aspect(1)
    
def plotLapErrorContour(filename, n, ax, vmin=-100, vmax=100, normalise = False, color="magma"):
    """Plot the spatial dependence of Laplace Op. error
    
    filename - filename with our approximations
    n - stencil size
    ax - to plot it on
    vmin - vmin to use in colorscale
    vmax - vmax to use in colorscale
    normalise - whether to normalise the errors to +-1
    color - cmap used (string)
    """
    
    d = getContent(filename)
    x,y = d['positions']
    real = [f(xx,yy,True) for xx,yy in zip(x,y)]
    absErrors = []
    u = d[f'derXSize{n}'] - real
    if normalise:
        u = np.array([1 if i>=0 else -1 for i in u])
    maska = bndBallVec(x,y)
    x = ma.array(x, mask=maska)
    y = ma.array(y, mask=maska)
    u = ma.array(u, mask=maska)
    lapErrors[0] = min(np.amin(u), lapErrors[0])
    lapErrors[1] = max(np.amax(u), lapErrors[1])
    norm = mpl.colors.SymLogNorm(1e-7, vmin=vmin, vmax=vmax)
    ax.scatter(x,y,c=u,norm=norm, cmap=plt.get_cmap(color), s=0.1)
    #ax.scatter(x,y,c=u,norm=norm)
    #ax.set_aspect(1)
    
def plotSolutionSpecific(fname,funk, ax):
    """Plot the given solution
    fname - filename used for position nodes
    funk - the solution to be plotted
    ax - ax to plot on
    """
    
    d = getContent(fname)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy in zip(x,y)]
    norm = mpl.colors.Normalize(vmin=np.amin(real),vmax=np.amax(real))
    sc = ax.scatter(x,y,c=real,norm=norm, cmap=plt.get_cmap("winter"),s=0.1)
    return sc

def plotSolution():
    """Makes the Solution plot for the paper
    """
    
    fig, ax = plt.subplots(figsize=(10,4))    
    sc = plotSolutionSpecific("Data/PoissonResults.h5",f, ax)
    ax.set_xlabel("$x$", fontsize=18.5)
    ax.set_ylabel("$y$", fontsize=18.5)
    adjustTickFont(ax,labelsize=18)
    ax.set_aspect(1)
    #ax.set_title(r"$u(x,y) = \sin (\pi x) \sin (\pi y)$")
    cb = fig.colorbar(sc, ax=ax, pad=0.005)
    cb.ax.tick_params(labelsize=18)
    cb.set_label(r"$u$", size=18.5)
    plt.tight_layout()
    plt.savefig("../FiguresPaper/Solution.png",dpi=300, transparent = False, bbox_inches='tight')


    
def plotGraphAndContours():
    """Plot the error and the 4 contours for paper"""
    
    nsOfInterest = [17,28,34,46]
    fig = plt.figure(figsize=(8,4), constrained_layout=True)
    gs = fig.add_gridspec(2,17)
    ax = fig.add_subplot(gs[:,:8])
    ax.grid(True)
    ax.set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$", fontsize=15)
    ax.set_xlabel(r"$n$", fontsize=15)
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax)
    xdata = ax.lines[0].get_xdata()
    ydata = ax.lines[0].get_ydata()
    #ax.tick_params(axis='y', which='both',left=False,labelleft=False)
    #ax.tick_params(axis='x', which='both',bottom=False,labelbottom=False)
    #ax.grid()
    vmin = np.inf
    vmax = -np.inf
    for n in nsOfInterest:
        vm = obtainErrorBounds("Data/PoissonResults.h5", n)
        vmin = min(vmin,vm[0])
        vmax = max(vmax,vm[1])
    ax1 = fig.add_subplot(gs[0,8:12])
    ax2 = fig.add_subplot(gs[0,12:16])
    ax3 = fig.add_subplot(gs[1,8:12])
    ax4 = fig.add_subplot(gs[1,12:16])
    axes = [ax1,ax2,ax3,ax4]
    colors = ["g","r","m","c"]
    for i in range(4):
        plotPoissonErrorContour("Data/PoissonResults.h5", nsOfInterest[i], axes[i],vmin=vmin,vmax=vmax)
        axes[i].get_xaxis().set_ticks([])
        axes[i].get_yaxis().set_ticks([])
        ax.plot([nsOfInterest[i]],[ydata[np.where(xdata == nsOfInterest[i])]],"o", color=colors[i])
        for side in axes[i].spines:
            axes[i].spines[side].set_color(colors[i])
        axes[i].set_title(f"$n={nsOfInterest[i]}$", color=colors[i], fontsize=15)
        axes[i].set_aspect(1)
    
    #fig.subplots_adjust(right=0.8)
    #cbar_ax = fig.add_axes([0.85, 0.15, 0.05, 0.7])
    cbar_ax = fig.add_subplot(gs[:,16])
    norm = mpl.colors.SymLogNorm(1e-7, vmin=vmin, vmax=vmax)
    cb = mpl.colorbar.ColorbarBase(cbar_ax, cmap=plt.get_cmap("viridis"), norm=norm,orientation = 'vertical')
    cb.set_label(r"$e_\mathrm{poiss}^\pm$", size=15)
    #plt.margins(x=0,y=0)
    adjustTickFont(ax,cbar_ax, labelsize=15)
    plt.savefig("../FiguresPaper/PlotWithContours.png", dpi=300, transparent=False, bbox_inches='tight')


def plotConvergence():
    """Plot the graph showing the convergence"""
    
    scales = [1,5,10,20,30,50]
    fnames = [f"Data/PoissonResultshFactor{s}.h5" for s in scales]
    fig, ax= plt.subplots(1,2,figsize=(10,4), constrained_layout=True,sharey=True)
    #fig, ax = plt.subplots(1,2,figsize=(7,4), constrained_layout=True, sharey=True)

    ydatas = []
    
    for s,fN in zip(scales,fnames):
        checkPoisson(fN,list(range(10,70)),ax[0])
        ax[0].lines[-1].set_label(f"$h={s*0.001}$")
        ydatas.append(ax[0].lines[-1].get_ydata())
    ydatas = np.array(ydatas)
    ax[0].set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$", fontsize=20)
    ax[0].set_xlabel(r"$n$", fontsize=20)
    
    hs = [0.001*s for s in scales]
    cmap = plt.get_cmap("cool")
    colors = [cmap(s) for s in np.linspace(0,1,16)]
    for i,n in enumerate(range(20,36)):
        ax[1].plot(hs,ydatas[:,n-10], color=colors[i],marker=".")
        if n%5==0:
            ax[1].lines[-1].set_label(f"$n={n}$")
    ax[1].set_yscale("log")
    ax[1].set_xscale("log")
    ax[1].invert_xaxis()
    ax[1].set_xlabel(r"$h$", fontsize=20)
    #ax[1].get_yaxis().set_visible(False)
    #ax[1].set_yticklabels([])

    #ax[0].set_ylim(4.9*1e-7,1e-3)
    #ax[1].set_ylim(4.9*1e-7,1e-3)
    adjustTickFont(ax[0],ax[1],labelsize=18)
    ax[0].grid()
    ax[1].grid(which='both', axis='x')
    ax[1].grid(which='major', axis='y')
    ax[1].legend(fontsize=17, loc="upper right")
    #ax[1].set_xticks([1e-2,4e-3,2e-3])
    #ax[1].set_xticks([],minor=True)
    ax[0].legend(fontsize=17, loc="upper right", ncols=1, columnspacing=1, handlelength=1, handletextpad=0.1)

    plt.savefig("../FiguresPaper/Convergence.png", dpi=300, transparent=False,bbox_inches='tight')
    
def plotBndFixed():
    """Plot the graph showing the boundary (non)effect"""
    
    fig, ax = plt.subplots(1,2,figsize=(10,5), constrained_layout=True)
    #d = getContent("Checks/PoissonResultsX5BndFixed.h5")
    d = getContent("Data/PoissonResultsBndFixed.h5")
    x , y = d['positions']
    inside = np.where((x-0.5)**2+(y-0.5)**2 <= 0.4**2)
    outside = np.where((x-0.5)**2+(y-0.5)**2 > 0.4**2)
    ax[0].scatter(x[inside],y[inside],c='k',s=0.1)
    ax[0].scatter(x[outside],y[outside],c='r', s=0.1)
    ax[0].set_xlabel(r"$x$", fontsize=20)
    ax[0].set_ylabel(r"$y$", fontsize=20)
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax[1])
    #checkPoisson("Checks/PoissonResultsX5.h5",list(range(10,70)),ax[1],funk=lambda x,y : x**5)
    ax[1].lines[-1].set_label('No fixed region')
    checkPoisson("Data/PoissonResultsBndFixed.h5",list(range(10,70)),ax[1])
    #checkPoisson("Checks/PoissonResultsX5BndFixed.h5",list(range(10,70)),ax[1],funk=lambda x,y : x**5)
    ax[1].lines[-1].set_label('Red fixed')
    checkPoisson("Data/PoissonResultsIntFixed.h5",list(range(10,70)),ax[1])
    #checkPoisson("Checks/PoissonResultsX5IntFixed.h5",list(range(10,70)),ax[1],funk=lambda x,y : x**5)
    ax[1].lines[-1].set_label('Black fixed')
    ax[1].grid()
    radius = d['Radiuses']
    thetas = set()
    
    rng = np.random.default_rng(1)
    chosen = rng.choice(len(x),100000)
    for i in chosen:
        xx = x[i]
        yy = y[i]
        r = radius[i]
        r0 = np.sqrt((xx-0.5)**2+(yy-0.5)**2)
        if r0 < 0.39 or r0 > 0.4:
            continue
        theta = np.arctan2(yy-0.5,xx-0.5)
        thetaNorm = int(theta/(2*np.pi)*20)
        if thetaNorm in thetas:
            continue
        thetas.add(thetaNorm)
        
        xlinspace = np.linspace(xx-r+1e-10,xx+r-1e-10,100)
        yup =  yy + np.sqrt(r*r-(xlinspace-xx)**2)
        ydown =  yy - np.sqrt(r*r-(xlinspace-xx)**2)
        ax[0].plot(xlinspace,yup,'g')
        ax[0].plot(xlinspace,ydown,'g')
    ax[0].lines[-1].set_label('Stencil radius')
    #ax[0].legend(markerscale=10, fontsize=20, loc="lower center")
    ax[0].set_aspect(1)
    ax[1].set_xlabel(r"$n$", fontsize=20)
    ax[1].set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$", fontsize=20)
    #ax[1].yaxis.set_label_position("right")
    #ax[1].yaxis.tick_right()
    ax[1].legend(fontsize=20, loc=(0.305,0.7))
    adjustTickFont(ax[0],ax[1],labelsize=20)
    plt.savefig("../FiguresPaper/BndFixed.png", dpi=300, transparent=False, bbox_inches='tight')



    
def plotPoissAndLapMetricContours():
    """Plot the figure displaying our metric"""
    
    fig = plt.figure(figsize=(10,6), constrained_layout=True)
    gs = fig.add_gridspec(3,6,height_ratios=[2,1,1], width_ratios=[1,1,1,1,1,0.2])
    ax = fig.add_subplot(gs[0,:])
    ax2 = ax.twinx()
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax)
    line = ax.get_lines()[0]
    line.set_color("b")
    line.set_label(r"$e_\mathrm{poiss}^\mathrm{max}$")
    line.set_marker("+")
    ax.tick_params(axis='y', which="both",colors="b")
    ax.set_xlabel(r"$n$", fontsize=20)
    #ax.xaxis.tick_top()
    #ax.xaxis.set_label_position('top') 

    checkPoisson("Data/PoissonResults.h5", list(range(10,70)), ax2, numberMetric=True)
    line = ax2.get_lines()[0]
    line.set_color("r")
    #line.set_linestyle("--")
    line.set_label(r"$\delta N_\mathrm{poiss}^\pm$")
    line.set_marker(".")
    
    checkLaplaceErrors("Data/LaplaceOpResults.h5", ax2, numberMetric=True)
    line = ax2.get_lines()[1]
    line.set_color("r")
    line.set_label(r"$\delta N_\mathrm{lap}^\pm$")
    line.set_linestyle("--")
    line.set_marker("x")
    #ax2.plot(line.get_xdata(), line.get_ydata(),marker="o")

    ax2.tick_params(axis='y', which="both",colors='r')
    #handles, labels = [(a + b) for a, b in zip(ax.get_legend_handles_labels(), ax2.get_legend_handles_labels())]
    ns = [17,27,28,29,34]
    ax2.grid()
    ax2.axhline(y=0,color='orange')
    ax.grid(axis='x')
    #ax.legend(handles, labels, loc="upper right", fontsize=20)
    ax2.legend(loc="upper right", fontsize=20, ncols=2, columnspacing=1, handletextpad=0.1)
    ax.legend(loc=(0.8,0.2), fontsize=20, handletextpad=0.1)
    adjustTickFont(ax,ax2)
    axi = [[],[]]
    color = "viridis"
    for i,n in enumerate(ns):
        axi[0].append(fig.add_subplot(gs[1,i]))
        axi[1].append(fig.add_subplot(gs[2,i]))
    
    for i,n in enumerate(ns):
        plotPoissonErrorContour("Data/PoissonResults.h5", n, axi[0][i], normalise=True, vmin=-1, vmax=1, color=color)
        plotLapErrorContour("Data/LaplaceOpResults.h5",n,axi[1][i], normalise=True, vmin=-1, vmax=1, color=color)
        axi[0][i].set_aspect(1)
        axi[1][i].set_aspect(1)
    for i in range(2):
        for j in range(5):
            axi[i][j].set_xticks([])
            axi[i][j].set_yticks([])
    #axi[0][0].set_ylabel(r"$e_\mathrm{poiss}^\pm$", fontsize=20)
    #axi[1][0].set_ylabel(r"$e_\mathrm{lap}^\pm$", fontsize=20)
        
    ydata = ax.lines[0].get_ydata()
    ydata = [ydata[i-10] for i in ns]
    ax.plot(ns,ydata,"ko")
    for i in range(5):
        addArrow(fig, ax, axi[0][i], [ns[i],ydata[i]], [0.5,1])
    
    axi[0][0].set_ylabel(r"$e^\pm_\mathrm{poiss}$", fontsize=20)
    axi[1][0].set_ylabel(r"$e^\pm_\mathrm{lap}$", fontsize=20)
    legendax = fig.add_subplot(gs[1:,5])
    #legendax.axis('off')
    
    cmap = plt.get_cmap(color,2)
    cmap = mpl.colors.ListedColormap([cmap(0),cmap(1)])
    bounds = [0,5,10]
    norm = mpl.colors.BoundaryNorm(bounds,cmap.N)
    mpl.colorbar.ColorbarBase(legendax, cmap=cmap, norm=norm, boundaries=bounds, ticks=[2.5,7.5])
    legendax.set_yticklabels([r"$<0$", r"$>0$"])
    adjustTickFont(legendax)
    legendax.tick_params(axis=u'both', which=u'both',length=0)

    
    """
    patch1 = mpl.patches.Patch(color=plt.get_cmap("viridis")(0.0), label=r"$e_\mathrm{poiss}^\pm < 0$")
    patch2 = mpl.patches.Patch(color=plt.get_cmap("viridis")(1.0), label=r"$e_\mathrm{poiss}^\pm > 0$")
    patch3 = mpl.patches.Patch(color=plt.get_cmap("magma")(0.0), label=r"$e_\mathrm{lap}^\pm < 0$")
    patch4 = mpl.patches.Patch(color=plt.get_cmap("magma")(1.0), label=r"$e_\mathrm{lap}^\pm > 0$")

    legendax.legend(handles=[patch1,patch2, patch3, patch4], fontsize=20, loc="right")
    """
    plt.savefig("../FiguresPaper/MetricContours.png", dpi=300, transparent=False, bbox_inches='tight')              

    

     
           
def plotPoissAndLapBothNorms():
    """Plot the first graph showing the minima"""
    
    fig, ax = plt.subplots(figsize=(10,4))
    ax2 = ax.twinx()
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax)
    ax.get_lines()[0].set_color("b")
    ax.get_lines()[0].set_label(r"$e_\mathrm{poiss}^\mathrm{max}$")
    checkPoisson("Data/PoissonResults.h5", list(range(10,70)),ax,aggFunk = np.mean)
    ax.lines[-1].set_color("b")
    ax.lines[-1].set_linestyle(":")
    ax.lines[-1].set_marker(".")
    ax.lines[-1].set_label(r"$e_\mathrm{poiss}^\mathrm{avg}$")
    
    ax.tick_params(axis='y', which="both",colors="b")
    ax.set_xlabel("$n$", fontsize=17)

    #ax.set_title("Approximation error dependence on stencil size")
    checkLaplaceErrors("Data/LaplaceOpResults.h5", ax2)
    ax2.get_lines()[0].set_color("r")
    ax2.get_lines()[0].set_label(r"$e_\mathrm{lap}^\mathrm{max}$")
    checkLaplaceErrors("Data/LaplaceOpResults.h5",ax2, aggFunk = np.mean)
    ax2.lines[-1].set_color("r")
    ax2.lines[-1].set_linestyle(":")
    ax2.lines[-1].set_marker(".")
    ax2.lines[-1].set_label(r"$e_\mathrm{lap}^\mathrm{avg}$")
    ax.grid()
    ax2.tick_params(axis='y', which="both",colors='r')
    handles, labels = [(a + b) for a, b in zip(ax.get_legend_handles_labels(), ax2.get_legend_handles_labels())]
    fig.legend(handles, labels, loc = "upper center", ncols=4,fontsize=17)
    ax2.set_ylim(1e-3,1e-1)
    adjustTickFont(ax,ax2,labelsize=17)
    plt.savefig("../FiguresPaper/MeanErrors.png", dpi=300, transparent=False,bbox_inches='tight')
    

if __name__ == "__main__":

    # ===== Functions used in paper ====
    print("Making a solution plot (Figure 1)...")
    plotSolution()
    plt.clf()
    print("Making an error(stencil size) plot, (Figure 2)...")
    plotPoissAndLapBothNorms()
    plt.clf()
    print("Making a convergence plot (Fig 3)...")
    plotConvergence()
    plt.clf()
    print("Making a Boundary effect plot (Fig 4)...")
    plotBndFixed()
    plt.clf()
    print("Making a contours plot (Fig 5)...")
    plotGraphAndContours()
    plt.clf()
    print("Making a metricp lot (Fig 6)...")
    plotPoissAndLapMetricContours()
    print("Done!")



    #=== Functions below are not used in this paper
    #plotWLSPaper()
    #checkMonomialsMetric()
    #fig, ax = plt.subplots()
    #checkPoisson("PoissonResultsFuncexp.h5", list(range(10,70)), ax,funk=lambda x,y:np.exp(x*x+y*y))
    #checkPoisson("PoissonResultsDoubleExp.h5", list(range(10,70)), ax,funk=lambda x,y: 4*np.exp(x*x+y*y)*(1+x*x+y*y))

    #plotPoissAndLap()
    #plotSpatial()
    #plotMoreFunctions()
    #plotMoreFunctionsSign()
    #plotBothSigns()
    #plotBothSignsVertical()
    
    #plotMoreFunctionsNewMetric()
    #plotPoissAndLapMetric()
    #shiftDependence()
    #plotErrorWithStencil()
    
    # ==== Other functions used for reference
    #getSpectra()
    #checkSpectra()
    #checkSpectraPos()
    
    #checkEffect(["PoissonResults.h5","Checks/PoissonResultsBicgstab.h5"],["SparseLU","BiCGSTAB"],list(range(10,70)))
    #checkEffect([f"Checks/PoissonResultsSeed{i}.h5" for i in range(1,6)],[f"Seed {i}" for i in range(1,6)], list(range(10,70)))
    #checkEffect([f"PoissonResultshFactor{i}.h5" for i in range(2,11,2)],[f"h = 0.001 * {i}" for i in range(2,11,2)], list(range(10,70)))
    #checkEffect([f"Checks/PoissonResultsDomainInd{i}.h5" for i in range(1,5)], ["Ball","Box","Box rotated by pi/4", "Triangle"], list(range(10,70)))
    #checkEffectMonomial()
    #=== Legacy
    
    
    
    
    
#Functions below are not used in the paper


    
def checkEffectMonomial():
    """Function meant to plot effect (e(n) and contours during minimum) of various
    changes to our setup"""

    default = False

    if default:
        fnames = [f"PoissonResultsm{i}.h5" for i in range(1,7)]
    else:
        fnames = [f"Checks/PoissonResultsX6m{i}.h5" for i in range(1,7)]
    names = [f"m {i}" for i in range(1,7)]
    minimal = [int(0.5*(m+1)*(m+2))+1 for m in range(1,7)]
    minimal[0] = minimal[0]+1 #m=1 poseben
    supports = [list(range(m,70)) for m in minimal]
    
    fig = plt.figure(figsize=(7,4), constrained_layout=True)
    numx=7
    gs = fig.add_gridspec(5,numx+3, width_ratios=[2] + [1]*(numx+2))
    ax = fig.add_subplot(gs[:3,:2])
    legendax = fig.add_subplot(gs[3:,:2])
    colorCycle = plt.rcParams['axes.prop_cycle'].by_key()['color']

    for i, (fname, name) in enumerate(zip(fnames,names)):
        if default:
            checkPoisson(fname,supports[i],ax)
        else:
            checkPoisson(fname,supports[i],ax,funk=lambda x,y : x**6)
        ax.lines[-1].set_label(name)
    handles, labels = ax.get_legend_handles_labels()
    legendax.legend(handles, labels)
    legendax.axis('off')
    #ax.fill_between(x=[24,24+numx],y1=1e-7,y2=1e-3,color='k',alpha=0.1)
    ax.set_ylim(1e-7,1)
    for i, fname in enumerate(fnames):
        if i==5:
            break
        solax = fig.add_subplot(gs[i,2])
        if default:
            plotSolutionSpecific(fname,lambda x,y : np.sin(np.pi*x)*np.sin(np.pi*y),solax)
        else:
            plotSolutionSpecific(fname,lambda x,y : x**6,solax)
        solax.set_aspect(1)
        solax.get_xaxis().set_ticks([])
        solax.get_yaxis().set_ticks([])
        if i==0:
            solax.set_title(r"$u(x,y)$")
        for side in solax.spines:
            solax.spines[side].set_color(colorCycle[i])
    if default:
        startingForPlot = [25,35,24,37,50, 40] #sin
    else:
        startingForPlot = [36,22,37,40,40,40]#x5
    ns = [list(range(i,i+numx)) for i in startingForPlot]
    for i, fname in enumerate(fnames):
        if i==5:
            break
        vmin=100
        vmax=-100
        for j in range(numx):
            if default:
                vmin2,vmax2 = obtainErrorBounds(fname,ns[i][j])
            else:
                vmin2,vmax2 = obtainErrorBounds(fname,ns[i][j],funk=lambda x,y : x**6)
            vmin = min(vmin,vmin2)
            vmax = max(vmax,vmax2)
        for j in range(numx):
            newax = fig.add_subplot(gs[i,3+j])
            if default:
                plotPoissonErrorContour(fname,ns[i][j],newax,vmin=vmin, vmax=vmax)
            else:
                plotPoissonErrorContour(fname,ns[i][j],newax,vmin=vmin, vmax=vmax,funk=lambda x,y:x**6)
            newax.set_aspect(1)
            newax.get_xaxis().set_ticks([])
            newax.get_yaxis().set_ticks([])
            for side in newax.spines:
                newax.spines[side].set_color(colorCycle[i])
            #newax.text(1,1,f"$n={ns[i][j]}$")
            newax.set_title(f"$n={ns[i][j]}$") 

def checkMonomialsMetric():

    fnames1 = [f"PoissonResultsm{i}.h5" for i in range(1,6)]
    fnames2 = [f"LaplaceOpResultsm{i}.h5" for i in range(1,6)]
    names = [f"$m = {i}$" for i in range(1,6)]
    minimal = [int(0.5*(m+1)*(m+2)) for m in range(1,6)]
    minimal[0] = minimal[0]+1 #m=1
    supports = [list(range(m,70)) for m in minimal]
    
    fig, ax = plt.subplots(2,figsize=(7,4), constrained_layout=True, sharex=True)
    ax[0].set_ylim(1e-8,1)
    colorCycle = plt.rcParams['axes.prop_cycle'].by_key()['color']

    for i, (fname, name) in enumerate(zip(fnames1,names)):
        checkPoisson(fname,supports[i],ax[0])
        ax[0].lines[-1].set_label(name)
    ax[0].legend()
    ax[0].set_ylabel(r"$e$")
    ax[0].get_xaxis().set_visible(False)
    for i,(fname1,fname2) in enumerate(zip(fnames1,fnames2)):
        checkPoisson(fname1, supports[i], ax[1],numberMetric=True)
        ax[1].lines[-1].set_color(colorCycle[i])
        checkLaplaceErrors(fname2, ax[1],numberMetric=True)
        ax[1].lines[-1].set_color(colorCycle[i])
        ax[1].lines[-1].set_linestyle("--")
    ax[1].set_ylabel(r"$\delta N_\pm$")
    ax[1].set_xlabel(r"$n$")
    plt.savefig("../FiguresPaper/DifferentOrders.png", bbox_inches='tight')


def plotWLSPaper():
    fig= plt.figure(figsize=(8,8), constrained_layout=True)
    gs = fig.add_gridspec(9,6,height_ratios=[1,1,1,1,3,1,1,1,1])
    ax = fig.add_subplot(gs[4,:])
    ax.grid(True)
    checkPoisson("PoissonResults.h5",list(range(10,70)),ax)
    ydata = ax.lines[-1].get_ydata()
    ax.plot([17],[ydata[7]],"ro")
    ax.axvspan(14, 22, color='red',alpha=0.2)
    ax.axvline(x=14,color='k',ls="--")
    ax.axvline(x=22,color='k',ls="--")
    ax.set_xlabel(r"$n$")
    ax.set_ylabel(r"$e_\infty$")
    starty=5
    startx=0
    for i in range(9):
        newax = fig.add_subplot(gs[starty+i//3,startx+i%3])
        plotPoissonErrorContour("PoissonResults.h5",17+i,newax,vmin=-1,vmax=1,normalise=True)
        newax.set_xticks([])
        newax.set_yticks([])
        newax.set_aspect(1)
        newax.set_title(f"$n={17+i}$")
        if i==0:
            for side in newax.spines:
                newax.spines[side].set_color("red")
                newax.spines[side].set_linewidth(2)
        else:
            newax.axis('off')
        if i==1:
            addArrow(fig,ax,newax,(21.5,1e-5),(0.5,1))
            
    ax.axvspan(23, 35, color='green',alpha=0.2)
    ax.axvline(x=23,color='k',ls="--")
    ax.axvline(x=35,color='k',ls="--")
    ax.plot([28],[ydata[18]],"go")
    starty=0
    startx=0
    for i in range(13):
        newax = fig.add_subplot(gs[starty+i//4,startx+i%4])
        plotPoissonErrorContour("PoissonResults.h5",23+i,newax,vmin=-1,vmax=1,normalise=True)
        newax.set_xticks([])
        newax.set_yticks([])
        newax.set_aspect(1)
        newax.set_title(f"$n={23+i}$")
        if i==5:
            for side in newax.spines:
                newax.spines[side].set_color("green")
                newax.spines[side].set_linewidth(2)          
        else:
            newax.axis('off')
        if i==10:
            addArrow(fig,ax,newax,(28,4e-4),(0,0))
    ax.axvspan(36, 42, color='red',alpha=0.2)
    ax.axvline(x=36,color='k',ls="--")
    ax.axvline(x=42,color='k',ls="--")
    starty=5
    startx=3
    for i in range(7):
        newax = fig.add_subplot(gs[starty+i//3,startx+i%3])
        plotPoissonErrorContour("PoissonResults.h5",36+i,newax,vmin=-1,vmax=1,normalise=True)
        newax.set_xticks([])
        newax.set_yticks([])
        newax.set_aspect(1)
        newax.set_title(f"$n={36+i}$")
        newax.axis('off')
        if i==1:
            addArrow(fig,ax,newax,(40,3e-5),(0.5,1))
            
    ax.axvspan(44, 49, color='green',alpha=0.2)
    ax.axvline(x=44,color='k',ls="--")
    ax.axvline(x=49,color='k',ls="--")
    starty=0
    startx=4
    ax.plot([46],[ydata[36]],"go")

    for i in range(6):
        newax = fig.add_subplot(gs[starty+i//2,startx+i%2])
        plotPoissonErrorContour("PoissonResults.h5",44+i,newax,vmin=-1,vmax=1,normalise=True)
        newax.set_xticks([])
        newax.set_yticks([])
        newax.set_aspect(1)
        newax.set_title(f"$n={44+i}$")
        if i==2:
            for side in newax.spines:
                newax.spines[side].set_color("green")
                newax.spines[side].set_linewidth(2)
        else:
            newax.axis('off')
        if i==4:
            addArrow(fig,ax,newax,(46,4e-4),(0.5,0))
            
    
    
def plotSpatial():
    """Multiple plots of spatial errors
    """
    num=3
    fig = plt.figure(figsize=(7,4))
    gs = fig.add_gridspec(2,4*num+1, width_ratios = [1]*4*num + [0.5])
    firstFile = "PoissonResultsm2.h5"
    secondFile = "LaplaceOpResultsm2.h5"
    ns = [17,28,34]
    ns = [30,38,49] #m=2
    #ns = list(range(27,27+3))
    axi = [[],[]]
    for i in range(num):
        axi[0].append(fig.add_subplot(gs[0,4*i:4*i+4]))
        axi[1].append(fig.add_subplot(gs[1,4*i:4*i+4]))
    for i,n in enumerate(ns):
        plotPoissonErrorContour(firstFile, n, axi[0][i])
        plotLapErrorContour(secondFile,n,axi[1][i])
        axi[0][i].clear()
        axi[1][i].clear()
        axi[0][i].get_xaxis().set_visible(False)
        if i!=0:
            axi[0][i].get_yaxis().set_visible(False)
        axi[1][i].get_xaxis().set_visible(False)
        if i!=0:
            axi[1][i].get_yaxis().set_visible(False)
        axi[0][i].set_title(f"$n={n}$")
        
    for i,n in enumerate(ns):
        plotPoissonErrorContour(firstFile, n, axi[0][i], vmin=poissonErrors[0], vmax=poissonErrors[1])
        plotLapErrorContour(secondFile,n,axi[1][i], vmin=lapErrors[0], vmax=lapErrors[1])
        axi[0][i].set_aspect(1)
        axi[1][i].set_aspect(1)

    cbar_ax0 = fig.add_subplot(gs[0,4*num])
    norm0 = mpl.colors.SymLogNorm(1e-7, vmin=poissonErrors[0], vmax=poissonErrors[1])
    mpl.colorbar.ColorbarBase(cbar_ax0, cmap=plt.get_cmap("viridis"), norm=norm0,orientation = 'vertical', label=r"$e_i^s$")
    cbar_ax1 = fig.add_subplot(gs[1,4*num])
    norm1 = mpl.colors.SymLogNorm(1e-7, vmin=lapErrors[0], vmax=lapErrors[1])
    mpl.colorbar.ColorbarBase(cbar_ax1, cmap=plt.get_cmap("magma"), norm=norm1,orientation = 'vertical',label=r"$e_i^s$")
    axi[0][0].set_ylabel(r"Poisson error")
    axi[0][0].get_yaxis().set_ticks([])
    axi[1][0].set_ylabel(r"$\nabla^2$ error")
    axi[1][0].get_yaxis().set_ticks([])
    #plt.savefig("../FiguresPaper/TwoContours.png", bbox_inches='tight')
            
    